//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

var tajpu = {
	init: function() {
		var menu = document.getElementById('contentAreaContextMenu');
		menu.addEventListener('popupshowing', tajpu.montrado, false);
		document.addEventListener('click', tajpu.klaka_loko, false);
	},

	//////////////////////////////////////////////////////////////////////////////
	// Montru miajn funkciojn, simple se Malfaru montrita.
	montrado: function() {

		var nun_preferoj = Components.classes["@mozilla.org/preferences-service;1"].
			    getService(Components.interfaces.nsIPrefService).
			    getBranch("tajpu.");


		document.getElementById('context-tajpu-ABC').hidden = document.getElementById('context-undo').hidden;
		document.getElementById('context-tajpu-abc').hidden = document.getElementById('context-undo').hidden;

		if (nun_preferoj.getBoolPref('prefere_traduku_literojn'))
			document.getElementById('context-tajpu-traduku').hidden = document.getElementById('context-undo').hidden;
		else
			document.getElementById('context-tajpu-traduku').hidden = 'hidden';

		if (nun_preferoj.getBoolPref('prefere_analizu_literojn'))
			document.getElementById('context-tajpu-analizu').hidden = document.getElementById('context-copy').hidden;
		else
			document.getElementById('context-tajpu-analizu').hidden = 'hidden';

		if (nun_preferoj.getBoolPref('prefere_de')) document.getElementById('context-tajpu-de').hidden = document.getElementById('context-undo').hidden;
		else document.getElementById('context-tajpu-de').hidden = 'hidden';
			
		if (nun_preferoj.getBoolPref('prefere_eo')) document.getElementById('context-tajpu-eo').hidden = document.getElementById('context-undo').hidden;
		else document.getElementById('context-tajpu-eo').hidden = 'hidden';

		if (nun_preferoj.getBoolPref('prefere_es')) document.getElementById('context-tajpu-es').hidden = document.getElementById('context-undo').hidden;
		else document.getElementById('context-tajpu-es').hidden = 'hidden';

		if (nun_preferoj.getBoolPref('prefere_fr')) document.getElementById('context-tajpu-fr').hidden = document.getElementById('context-undo').hidden;
		else document.getElementById('context-tajpu-fr').hidden = 'hidden';

		if (nun_preferoj.getBoolPref('prefere_pl')) document.getElementById('context-tajpu-pl').hidden = document.getElementById('context-undo').hidden;
		else document.getElementById('context-tajpu-pl').hidden = 'hidden';
	},

	//////////////////////////////////////////////////////////////////////////////
	klaka_loko: function(e) {
	  if (!e) e = window.event;
	  if (e.button != 2) return;
	  if (!e.target) return;
	  try {
  	  if (e.target.getAttribute("readonly") == "readonly") {
		  document.getElementById('context-tajpu').setAttribute("disabled", true);
  	  }
  	  else {
		  document.getElementById('context-tajpu').setAttribute("disabled", false);
  	  }
  	}
  	catch (e) {}
	},

	//////////////////////////////////////////////////////////////////////////////
	tajpu_literon: function(posxto, teksto) {

		if (posxto == 1) {
			theEditor = GetCurrentEditor();
  			if (theEditor) theEditor.insertText(teksto);
		}
		else {
			///var theBox = document.commandDispatcher.focusedElement;
			///theBox.value = theBox.value + teksto;
			var tajpejo = document.commandDispatcher.focusedElement;
			var oPosition = tajpejo.scrollTop;
			var oHeight = tajpejo.scrollHeight;
			tajpu.metu(tajpejo,teksto);
			var nHeight = tajpejo.scrollHeight - oHeight;
			tajpejo.scrollTop = oPosition + nHeight;
		}
	},

	//////////////////////////////////////////////////////////////////////////////

	analizu_literojn: function () {

		var fokusitaFenestro = document.commandDispatcher.focusedWindow;
		var selektajho = fokusitaFenestro.__proto__.getSelection.call(fokusitaFenestro);
		var teksto = String(selektajho);
		if (teksto.length==0)
		{
			gBrowser.selectedTab = gBrowser.addTab('http://lingvo.org/abcTajpu/analizu.html');
		}
		else
		{
			window.open('http://lingvo.org/cgi-bin/analizu?tt='+teksto, "Analizu tekston", "chrome,width=300,height=500");
		}
	},
		
	//////////////////////////////////////////////////////////////////////////////

	traduku_literojn: function() {

		var tajpejo = document.commandDispatcher.focusedElement;
		var teksto = tajpejo.value;


		teksto = teksto.replace(/\\A/g,"\u00C0");
		teksto = teksto.replace(/\\a/g,"\u00E0");
		teksto = teksto.replace(/\\E/g,"\u00C8");
		teksto = teksto.replace(/\\e/g,"\u00E8");
		teksto = teksto.replace(/\\I/g,"\u00CC");
		teksto = teksto.replace(/\\i/g,"\u00EC");
		teksto = teksto.replace(/\\O/g,"\u00D2");
		teksto = teksto.replace(/\\o/g,"\u00F2");
		teksto = teksto.replace(/\\U/g,"\u00D9");
		teksto = teksto.replace(/\\u/g,"\u00F9");

		teksto = teksto.replace(/\/A/g,"\u00C1");
		teksto = teksto.replace(/\/a/g,"\u00E1");
		teksto = teksto.replace(/\/C/g,"\u0106");
		teksto = teksto.replace(/\/c/g,"\u0107");
		teksto = teksto.replace(/\/E/g,"\u00C9");
		teksto = teksto.replace(/\/e/g,"\u00E9");
		teksto = teksto.replace(/\/I/g,"\u00CD");
		teksto = teksto.replace(/\/i/g,"\u00ED");
		teksto = teksto.replace(/\/L/g,"\u0139");
		teksto = teksto.replace(/\/l/g,"\u013A");
		teksto = teksto.replace(/\/N/g,"\u0143");
		teksto = teksto.replace(/\/n/g,"\u0144");
		teksto = teksto.replace(/\/\/O/g,"\u0150");
		teksto = teksto.replace(/\/\/o/g,"\u0151");
		teksto = teksto.replace(/\/O/g,"\u00D3");
		teksto = teksto.replace(/\/o/g,"\u00F3");
		teksto = teksto.replace(/\/R/g,"\u0154");
		teksto = teksto.replace(/\/r/g,"\u0155");
		teksto = teksto.replace(/\/S/g,"\u015A");
		teksto = teksto.replace(/\/s/g,"\u015B");
		teksto = teksto.replace(/\/\/U/g,"\u0170");
		teksto = teksto.replace(/\/\/u/g,"\u0171");
		teksto = teksto.replace(/\/U/g,"\u00DA");
		teksto = teksto.replace(/\/u/g,"\u00FA");
		teksto = teksto.replace(/\/Z/g,"\u0179");
		teksto = teksto.replace(/\/z/g,"\u017A");

		teksto = teksto.replace(/\^A/g,"\u00C2");
		teksto = teksto.replace(/\^a/g,"\u00E2");
		teksto = teksto.replace(/\^C/g,"\u0108");
		teksto = teksto.replace(/\^c/g,"\u0109");
		teksto = teksto.replace(/\^E/g,"\u00CA");
		teksto = teksto.replace(/\^e/g,"\u00EA");
		teksto = teksto.replace(/\^G/g,"\u011C");
		teksto = teksto.replace(/\^g/g,"\u011D");
		teksto = teksto.replace(/\^H/g,"\u0124");
		teksto = teksto.replace(/\^h/g,"\u0125");
		teksto = teksto.replace(/\^I/g,"\u00CE");
		teksto = teksto.replace(/\^i/g,"\u00EE");
		teksto = teksto.replace(/\^J/g,"\u0134");
		teksto = teksto.replace(/\^j/g,"\u0135");
		teksto = teksto.replace(/\^O/g,"\u00D4");
		teksto = teksto.replace(/\^o/g,"\u00F4");
		teksto = teksto.replace(/\^S/g,"\u015C");
		teksto = teksto.replace(/\^s/g, "\u015D");
		teksto = teksto.replace(/\^U/g,"\u00DB");
		teksto = teksto.replace(/\^u/g,"\u00FB");
		teksto = teksto.replace(/\^W/g,"\u0174");
		teksto = teksto.replace(/\^w/g,"\u0175");
		teksto = teksto.replace(/\^Y/g,"\u0176");
		teksto = teksto.replace(/\^y/g,"\u0177");

		teksto = teksto.replace(/>C/g,"\u010C");
		teksto = teksto.replace(/>c/g,"\u010D");
		teksto = teksto.replace(/>D/g,"\u010E");
		teksto = teksto.replace(/>d/g,"\u010F");
		teksto = teksto.replace(/>E/g,"\u011A");
		teksto = teksto.replace(/>e/g,"\u011B");
		teksto = teksto.replace(/>N/g,"\u0147");
		teksto = teksto.replace(/>n/g,"\u0148");
		teksto = teksto.replace(/>R/g,"\u0158");
		teksto = teksto.replace(/>r/g,"\u0159");
		teksto = teksto.replace(/>S/g,"\u0160");
		teksto = teksto.replace(/>s/g,"\u0161");
		teksto = teksto.replace(/>T/g,"\u0164");
		teksto = teksto.replace(/>t/g,"\u0165");
		teksto = teksto.replace(/>Z/g,"\u017D");
		teksto = teksto.replace(/>z/g,"\u017E");
		
		teksto = teksto.replace(/\)A/g,"\u0102");
		teksto = teksto.replace(/\)a/g,"\u0103");
		teksto = teksto.replace(/\)E/g,"\u0114");
		teksto = teksto.replace(/\)e/g,"\u0115");
		teksto = teksto.replace(/\)G/g,"\u011E");
		teksto = teksto.replace(/\)g/g,"\u011F");
		teksto = teksto.replace(/\)I/g,"\u012C");
		teksto = teksto.replace(/\)i/g,"\u012D");
		teksto = teksto.replace(/\)O/g,"\u014E");
		teksto = teksto.replace(/\)o/g,"\u014F");
		teksto = teksto.replace(/\)U/g,"\u016C");
		teksto = teksto.replace(/\)u/g,"\u016D");

		teksto = teksto.replace(/~A/g,"\u00C3");
		teksto = teksto.replace(/~a/g,"\u00E3");
		teksto = teksto.replace(/~I/g,"\u0128");
		teksto = teksto.replace(/~i/g,"\u0129");
		teksto = teksto.replace(/~N/g,"\u00D1");
		teksto = teksto.replace(/~n/g,"\u00F1");
		teksto = teksto.replace(/~U/g,"\u0168");
		teksto = teksto.replace(/~u/g,"\u0169");
		
		teksto = teksto.replace(/\|A/g,"\u0100");
		teksto = teksto.replace(/\|a/g,"\u0101");
		teksto = teksto.replace(/\|E/g,"\u0112");
		teksto = teksto.replace(/\|e/g,"\u0113");
		teksto = teksto.replace(/\|I/g,"\u012A");
		teksto = teksto.replace(/\|i/g,"\u012B");
		teksto = teksto.replace(/\|O/g,"\u014C");
		teksto = teksto.replace(/\|o/g,"\u014D");
		teksto = teksto.replace(/\|U/g,"\u016A");
		teksto = teksto.replace(/\|u/g,"\u016B");
		
		teksto = teksto.replace(/\*A/g,"\u00C5");
		teksto = teksto.replace(/\*a/g,"\u00E5");
		teksto = teksto.replace(/\*U/g,"\u016E");
		teksto = teksto.replace(/\*u/g,"\u016F");

		teksto = teksto.replace(/\.E/g,"\u0116");
		teksto = teksto.replace(/\.e/g,"\u0117");
		teksto = teksto.replace(/\.G/g,"\u0120");
		teksto = teksto.replace(/\.g/g,"\u0121");
		teksto = teksto.replace(/\.I/g,"\u0130");
		teksto = teksto.replace(/\.L/g,"\u013F");
		teksto = teksto.replace(/\.l/g,"\u0140");

		teksto = teksto.replace(/:A/g,"\u00C4");
		teksto = teksto.replace(/:a/g,"\u00E4");
		teksto = teksto.replace(/:E/g,"\u00CB");
		teksto = teksto.replace(/:e/g,"\u00EB");
		teksto = teksto.replace(/:I/g,"\u00CF");
		teksto = teksto.replace(/:i/g,"\u00EF");
		teksto = teksto.replace(/:O/g,"\u00D6");
		teksto = teksto.replace(/:o/g,"\u00F6");
		teksto = teksto.replace(/:U/g,"\u00DC");
		teksto = teksto.replace(/:u/g,"\u00FC");
		teksto = teksto.replace(/:Y/g,"\u0178");
		teksto = teksto.replace(/:y/g,"\u00FF");
		
		teksto = teksto.replace(/,A/g,"\u0104");
		teksto = teksto.replace(/,a/g,"\u0103");
		teksto = teksto.replace(/,C/g,"\u00C7");
		teksto = teksto.replace(/,c/g,"\u00E7");
		teksto = teksto.replace(/,E/g,"\u0118");
		teksto = teksto.replace(/,e/g,"\u0119");
		teksto = teksto.replace(/,G/g,"\u0122");
		teksto = teksto.replace(/,g/g,"\u0123");
		teksto = teksto.replace(/,I/g,"\u012E");
		teksto = teksto.replace(/,i/g,"\u012F");
		teksto = teksto.replace(/,K/g,"\u0136");
		teksto = teksto.replace(/,k/g,"\u0137");
		teksto = teksto.replace(/,L/g,"\u013B");
		teksto = teksto.replace(/,l/g,"\u013C");
		teksto = teksto.replace(/,N/g,"\u0145");
		teksto = teksto.replace(/,n/g,"\u0146");
		teksto = teksto.replace(/,R/g,"\u0156");
		teksto = teksto.replace(/,r/g,"\u0157");
		teksto = teksto.replace(/,S/g,"\u015E");
		teksto = teksto.replace(/,s/g,"\u015F");
		teksto = teksto.replace(/,T/g,"\u0162");
		teksto = teksto.replace(/,t/g,"\u0163");
		teksto = teksto.replace(/,U/g,"\u0172");
		teksto = teksto.replace(/,u/g,"\u0173");

		teksto = teksto.replace(/=D/g,"\u0110");
		teksto = teksto.replace(/=d/g,"\u0111");
		teksto = teksto.replace(/=H/g,"\u0126");
		teksto = teksto.replace(/=h/g,"\u0127");
		teksto = teksto.replace(/=L/g,"\u0141");
		teksto = teksto.replace(/=l/g,"\u0142");
		teksto = teksto.replace(/=O/g,"\u00D8");
		teksto = teksto.replace(/=o/g,"\u00F8");
		teksto = teksto.replace(/=T/g,"\u0166");
		teksto = teksto.replace(/=t/g,"\u0167");

		teksto = teksto.replace(/!AE/g,"\u00C6");
		teksto = teksto.replace(/!ae/g,"\u00E6");
		teksto = teksto.replace(/!DH/g,"\u00D0");
		teksto = teksto.replace(/!dh/g,"\u00F0");
		teksto = teksto.replace(/!!i/g,"\u0131");
		teksto = teksto.replace(/!IJ/g,"\u0132");
		teksto = teksto.replace(/!ij/g,"\u0133");
		teksto = teksto.replace(/!!K/g,"\u0138");
		teksto = teksto.replace(/!OE/g,"\u0152");
		teksto = teksto.replace(/!oe/g,"\u0153");
		teksto = teksto.replace(/!ss/g,"\u00DF");
		teksto = teksto.replace(/!TH/g,"\u00DE");
		teksto = teksto.replace(/!th/g,"\u00FE");

		tajpejo.value = teksto;
	},

	//////////////////////////////////////////////////////////////////////////////
	metu: function(myField, myValue) {
  // Dankon al http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  // kaj al Cusser
    if (myField.selectionStart || myField.selectionStart == '0') {
      var startPos = myField.selectionStart;
      var endPos = myField.selectionEnd;
      myField.value = myField.value.substring(0, startPos)
      + myValue
      + myField.value.substring(endPos, myField.value.length);
      var cursorPos = endPos + myValue.length;
      myField.selectionStart = cursorPos;
      myField.selectionEnd = cursorPos;
    } 
    else {
      myField.value += myValue;
    }
  }
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
window.addEventListener('load', tajpu.init, false); 
